#include "pan_tompkins.h"

int32_t RR_interval(int32_t*  peak_locs, int32_t peaks_index, int32_t*  mean_RR2, int32_t*  THRESHOLD_I1, int32_t*  THRESHOLD_F1)
{
	static int32_t latest_QRS[QRS_size];
	static int32_t latest_RR[RR_size];
	uint32_t i, RR_within_range;

	latest_QRS[0]=peak_locs[indexWrap(peaks_index-QRS_size,peaks_size)];

	for(i=0; i<RR_size; i++)
	{
		latest_RR[RR_size-i-1]=0;
		latest_QRS[QRS_size-i-1]=peak_locs[indexWrap(peaks_index-i-1,peaks_size)];
	}

	difference_9(latest_QRS,latest_RR);
	int32_t mean_RR1=mean_8(latest_RR);

	if(peaks_index==9)
	{
		*mean_RR2=mean_RR1;
	}
	else
	{
		int32_t RR_low_threshold=(92*(*mean_RR2))/100; //0.92*mean_RR2
		int32_t RR_high_threshold=(116*(*mean_RR2))/100; //1.16*mean_RR2

		RR_within_range=1;
		for(i=0; i<RR_size; i++)
		{
			if((latest_RR[i]<=RR_low_threshold) || (latest_RR[i]>=RR_high_threshold))
				RR_within_range=0;
		}

		if(RR_within_range==1)
			*mean_RR2=mean_RR1;

		if((latest_RR[RR_size-1]<=RR_low_threshold) || (latest_RR[RR_size-1]>=RR_high_threshold))
		{
			*THRESHOLD_I1=(*THRESHOLD_I1)/2;
			*THRESHOLD_F1=(*THRESHOLD_F1)/2;
		}
	}

	return(*mean_RR2);
}
