#include "pan_tompkins.h"

void is_T_wave(int32_t* peak_locs,int32_t  peaks_index,int32_t highpass_local_max,int32_t* NPKF,int32_t* NPKI,int32_t* integration,int32_t* skip,int32_t hp_5s_index, int32_t curr_index, int32_t prev_peak, int32_t* hp_5s)
{
    if((curr_index - peak_locs[indexWrap(peaks_index-1, peaks_size)]) <= MS_200) //R-peaks cannot physiologically occur within 200 ms of one another
	{
    	if(highpass_local_max>hp_5s[prev_peak])	 //if the current peak is greater than the last detected peak, replace the last detected peak
    	{
    		*skip=0;
    	}
    	else
    	{
    		*skip = 1;							//else skip the current peak
            *NPKF = (highpass_local_max + 7*(*NPKF))/8;
            *NPKI = (integration[hp_5s_index] + 7*(*NPKI))/8;
    	}
	}
    else if (curr_index - peak_locs[indexWrap(peaks_index-1,peaks_size)] <= MS_360)
	{
		int32_t  integration_buffer[MS_75+1];
		int32_t  diff_buffer[MS_75];
		int32_t  j;
			
		for(j=0;j<MS_75;j++)
		{
			integration_buffer[j]=integration[indexWrap(hp_5s_index+j,FS5)];
			diff_buffer[j]=0;
		}
			
		integration_buffer[MS_75]=integration[indexWrap(hp_5s_index+MS_75,FS5)];
		difference(integration_buffer,diff_buffer,MS_75);				//find the mean slope of the current peak
		int32_t Slope1 = mean(diff_buffer,MS_75+1);
		
		for(j=0;j<MS_75;j++)
		{
			integration_buffer[j]=integration[indexWrap(prev_peak+j,FS5)];
			diff_buffer[j]=0;
		}
			
		integration_buffer[MS_75]=integration[indexWrap(prev_peak+MS_75,FS5)];
		difference(integration_buffer,diff_buffer,MS_75);				//find the mean slope of the last detected peak
		int32_t Slope2 = mean(diff_buffer,MS_75+1);
			
        if (abs_ecg(Slope1) <= (abs_ecg(Slope2/2)))		//if the current slope is less than half of slope of the last detected peak, skip the peak
		{
            *skip = 1; 
			*NPKF = (highpass_local_max + 7*(*NPKF))/8;
			*NPKI = (integration[hp_5s_index] + 7*(*NPKI))/8;
		}
        else
        {
            *skip = 0;
        }
	}
}

void find_QRS(int32_t* peak_locs,int32_t* peaks_index,int32_t  highpass_local_max_index,int32_t  highpass_local_max,int32_t* SPKF,int32_t* SPKI,int32_t* integration,int32_t hp_5s_index,int32_t curr_index, int32_t* prev_peak, int32_t* hp_5s, int32_t* blank_flag, int32_t* blank_count)
{
	if(*peaks_index==0) //if no peaks have been detected
	{
		peak_locs[indexWrap(*peaks_index,peaks_size)]=curr_index-highpass_local_max_index;
		*prev_peak=indexWrap(hp_5s_index+highpass_local_max_index,FS5);
		(*peaks_index)++;
		*blank_flag=1;
	}
	else if(curr_index-highpass_local_max_index-(peak_locs[indexWrap(*peaks_index-1,peaks_size)])>=MS_200) //if the current peak is more than 200 ms after the last detected peak
	{
		peak_locs[indexWrap(*peaks_index,peaks_size)]=curr_index-highpass_local_max_index;
		*prev_peak=indexWrap(hp_5s_index+highpass_local_max_index,FS5);
		(*peaks_index)++;
		*blank_flag=1;
	}
	else if(highpass_local_max>hp_5s[*prev_peak])  //if the current peak is greater than the last detected peak
	{
		peak_locs[indexWrap(*peaks_index-1,peaks_size)]=curr_index-highpass_local_max_index;
		*prev_peak=indexWrap(hp_5s_index+highpass_local_max_index,FS5);
		*blank_count=0;
	}

    *SPKF = (highpass_local_max + 7*(*SPKF))/8;
    *SPKI = (integration[hp_5s_index] + 7*(*SPKI))/8;
}
