/*
 * ecg_adc.h
 *
 *  Created on: Jan 31, 2017
 *      Author: edward
 */

#ifndef INC_ECG_ADC_H_
#define INC_ECG_ADC_H_

#include <csl_sar.h>

//Select ADC channel ECG sensor is connected to
//GPAIN0 -> CHAN1
//GPAIN2 -> CHAN4
//GPAIN3 -> CHAN5
//See Fig. 1 of TI SAR documentation (sprufp1c)
#define ECG_SENSOR_CHANNEL	CSL_SAR_CHAN_4
#define ADC_CLKDIV	0x0100

extern CSL_SarHandleObj	hSar;

/*Function: initialize_adc
 *Initializes analog digital converter
 *Return 'true' if successful
 **/
Uint16 initialize_adc(void);

/*Function: disable_adc
 *Shuts down the ADC
 *Return 'true' if successful
 */
Uint16 disable_adc(void);

#endif /* INC_ECG_ADC_H_ */
