/*
 * ecg_uart.h
 *
 *  Created on: Feb 6, 2017
 *      Author: edward
 */

#ifndef INC_ECG_UART_H_
#define INC_ECG_UART_H_

#include <csl_uart.h>
#include <csl_uartAux.h>
#include <csl_sysctrl.h>

extern CSL_UartHandle hUart;

#define UART_WRITE_TIMEOUT 2000
#define UART_READ_TIMEOUT 0000

/*Function: initialize_uart
 *Initializes UART interface
 *Return 'true' if successful
 **/
Bool initialize_uart(void);

Bool write_integer_uart(Int32 value);
int write_uart(Uint8 value);
int write_uart16(Uint16 value);

int write_flag(Uint8 flag);

/*
* Function: parse_uart_rx
* parses UART read buffer and handles received commands
* Return 'true' if command was successfully received and processed
*/
Bool parse_uart_rx(void);

void uart_rxIsr(void);

#endif /* INC_ECG_UART_H_ */
