/*
 * ecg_buffer.c
 *
 *  Created on: Jan 31, 2017
 *      Author: edward
 */

#include "ecg_buffer.h"
#include "ecg.h"

#include "rtecg.h"

Uint16 ecg_sensor_buffer_index;
Uint16 benchmark_data_buffer_index = 0;
Uint16 uart_read_buffer_index = 0;
char UART_read_buffer[UART_READ_BUFFER_SIZE];
Int32 ecg_sensor_buffer[SENSOR_BUFFER];
Int32 ecg_input_buffer[SENSOR_BUFFER];
/*Uint16 input_index;*/
Bool input_buffer_ready;
Int16 benchmark_data_buffer[BENCHMARK_DATA_SIZE];

Bool initialize_buffers(void){
	int i = 0;

	for(i = 0; i < SENSOR_BUFFER; i++){
		ecg_sensor_buffer[i] = 0;
		ecg_input_buffer[i] = 0;
	}

	for(i = 0; i < UART_READ_BUFFER_SIZE; i++){
		UART_read_buffer[i] = 0;
	}

	return TRUE;
}

Uint16 circular_buffer_index(Uint16 i, Int16 offset, Uint16 max_size){
	Uint16 i_next;
	if((signed)i < (-offset)){
		i_next = max_size + i + offset;
	}
	else{
		i_next = (i + offset) % max_size;
	}
	return i_next;
}

Bool add_to_sensor_buffer(Int16 data){
	//store in next buffer index
	ecg_sensor_buffer_index = circular_buffer_index(ecg_sensor_buffer_index, 1, SENSOR_BUFFER);
	ecg_sensor_buffer[ecg_sensor_buffer_index] = (Int32) data;
	//if sensor buffer is full, copy to output buffer and continue
	if(ecg_sensor_buffer_index == 0){
		memcpy(ecg_input_buffer, ecg_sensor_buffer, sizeof(ecg_input_buffer));
		input_buffer_ready = TRUE;
	}

	return TRUE;
}

